#include "common.h"
#include "tbb/concurrent_hash_map.h"

// STL map that maps strings to ints
tbb::concurrent_hash_map<std::string, int> FineGrainStringTable;

void FineGrainClear() {
    FineGrainStringTable.clear();
}

void FineGrainUpdate( const std::string& key ) {
    // FIXME - implement the update and remove the exception.
    // Hint: The code is somewhat like that of FineGrainGet, except:
    //    Use insert instead of find.
    //    Use an accessor instead of a const_accessor.
    //    Increment "->second" instead of returning it.
    throw std::logic_error("not implemented");
}

int FineGrainGet( const std::string& key ) {
    tbb::concurrent_hash_map<std::string, int>::const_accessor a;
    if( FineGrainStringTable.find(a,key) )
        return a->second;
    else
        return 0;
}
