#include "common.h"
#include "tbb/task_group.h"
using namespace tbb;

void ParallelKaratsubaMul( Digit z[], const Digit x[], const Digit y[], size_t n ) {
    if( n<=CutOff ) {
        SimpleMul( z, x, y, n );
    } else {
        ... FIXME - create a task_group g...
        ... use g.run(...) to start two of the recursive calls in parallel
        ... run the third call concurrentlhy while the other two are running
        ... wait for all thread to finish and do the final operations 
        ... remember to recusively call the parallel version, not the serial version :-)
#if 0
        size_t m = n/2;
        SerialKaratsubaMul( z, x, y, m );
        SerialKaratsubaMul( z+n, x+m, y+m, m );
        TempSpace s(3*n);
        Digit* a = s+0;
        Digit* b = s+n;
        Digit* c = s+2*n;
        Add( a, x, x+m, m );
        Add( b, y, y+m, m ); 
        SerialKaratsubaMul( c, a, b, m ); 
        AssignSubSub( c, z, z+n, n );
        Add( z+m, z+m, c, n ); 
#endif
    }
}

