#include "common.h"

// Set c = matrix product of a and b
void SerialMatrixMultiply (float c[N][N], const float a[N][N], const float b[N][N]) {
    for (size_t i = 0; i < N; ++i ) {
        for (size_t j = 0; j < N; ++j ) {
            float sum = 0;
            for (size_t k = 0; k < N; ++k ) 
                sum += a[i][k]*b[k][j];
            c[i][j] = sum;
        }
    }
}

